/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of Tidy.xs. Do not edit this file, edit Tidy.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Tidy.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <tidy.h>
#include <buffio.h>
#include <stdio.h>
#include <errno.h>

#define HTMLTIDY_LOAD_CONFIG_HASH(tdoc,tidy_options) {                     \
    HE *entry;                                                             \
    (void) hv_iterinit(tidy_options);                                      \
    while ( entry = hv_iternext(tidy_options) ) {                          \
        I32 key_len;                                                       \
                                                                           \
        TidyOptionId id;                                                   \
                                                                           \
        SV *sv_data;                                                       \
        const char *data;                                                  \
        STRLEN data_len;                                                   \
                                                                           \
        const char * const key = hv_iterkey(entry,&key_len);               \
        const TidyOption opt = tidyGetOptionByName(tdoc,key);              \
        if (!opt) {                                                        \
            warn("HTML::Tidy: Unrecognized option: ``%s''\n",key);         \
            continue;                                                      \
        }                                                                  \
                                                                           \
        id = tidyOptGetId(opt);                                            \
        sv_data = hv_iterval(tidy_options,entry);                          \
        data = SvPV(sv_data,data_len);                                     \
                                                                           \
        if ( ! tidyOptSetValue(tdoc,id,data) ) {                           \
            warn("HTML::Tidy: Can't set option: "                          \
                 "``%s'' to ``%s''\n",                                     \
                 key, data);                                               \
        }                                                                  \
    }                                                                      \
}


#line 52 "Tidy.c"

XS(XS_HTML__Tidy__tidy_messages); /* prototype to pass -Wmissing-prototypes */
XS(XS_HTML__Tidy__tidy_messages)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: HTML::Tidy::_tidy_messages(input, configfile, tidy_options)");
    SP -= items;
    {
	const char *	input = (const char *)SvPV_nolen(ST(0));
	const char *	configfile = (const char *)SvPV_nolen(ST(1));
	HV *	tidy_options;
#line 53 "Tidy.xs"
        TidyBuffer errbuf = {0};
        TidyDoc tdoc = tidyCreate(); /* Initialize "document" */
        const char* newline;
        int rc = 0;
#line 70 "Tidy.c"

	if (SvROK(ST(2)) && SvTYPE(SvRV(ST(2)))==SVt_PVHV)
	    tidy_options = (HV*)SvRV(ST(2));
	else
	    Perl_croak(aTHX_ "tidy_options is not a hash reference");
#line 58 "Tidy.xs"
        tidyBufInit(&errbuf);
        rc = ( tidyOptSetValue( tdoc, TidyCharEncoding, "utf8" ) ? rc : -1 );

        if ( (rc >= 0 ) && configfile && *configfile ) {
            rc = tidyLoadConfig( tdoc, configfile );
        }

        if ( rc >= 0 ) {
            HTMLTIDY_LOAD_CONFIG_HASH(tdoc,tidy_options);
        }

        if ( rc >= 0 ) {
            /* Capture diagnostics */
            rc = tidySetErrorBuffer( tdoc, &errbuf );
        }

        if ( rc >= 0 ) {
            /* Parse the input */
            rc = tidyParseString( tdoc, input );
        }

        if ( rc >= 0 && errbuf.bp) {
            XPUSHs( sv_2mortal(newSVpvn(errbuf.bp, errbuf.size)) );

            /* TODO: Make this a function */
            switch ( tidyOptGetInt(tdoc,TidyNewline) ) {
                case TidyLF:
                    newline = "\n";
                    break;
                case TidyCR:
                    newline = "\r";
                    break;
                default:
                    newline = "\r\n";
                    break;
            }
            XPUSHs( sv_2mortal(newSVpv(newline, 0)) );
        }
        else {
            rc = -1;
        }

        tidyBufFree( &errbuf );
        tidyRelease( tdoc );

        if ( rc < 0 ) {
            XSRETURN_UNDEF;
        }
#line 125 "Tidy.c"
	PUTBACK;
	return;
    }
}


XS(XS_HTML__Tidy__tidy_clean); /* prototype to pass -Wmissing-prototypes */
XS(XS_HTML__Tidy__tidy_clean)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: HTML::Tidy::_tidy_clean(input, configfile, tidy_options)");
    SP -= items;
    {
	const char *	input = (const char *)SvPV_nolen(ST(0));
	const char *	configfile = (const char *)SvPV_nolen(ST(1));
	HV *	tidy_options;
#line 115 "Tidy.xs"
        TidyBuffer errbuf = {0};
        TidyBuffer output = {0};
        TidyDoc tdoc = tidyCreate(); /* Initialize "document" */
        const char* newline;
        int rc = 0;
#line 149 "Tidy.c"

	if (SvROK(ST(2)) && SvTYPE(SvRV(ST(2)))==SVt_PVHV)
	    tidy_options = (HV*)SvRV(ST(2));
	else
	    Perl_croak(aTHX_ "tidy_options is not a hash reference");
#line 121 "Tidy.xs"
        tidyBufInit(&output);
        tidyBufInit(&errbuf);
        /* Set our default first. */
        /* Don't word-wrap */
        rc = ( tidyOptSetInt( tdoc, TidyWrapLen, 0 ) ? rc : -1 );

        if ( (rc >= 0 ) && configfile && *configfile ) {
            rc = tidyLoadConfig( tdoc, configfile );
        }

        /* XXX I think this cascade is a bug waiting to happen */

        if ( rc >= 0 ) {
            rc = ( tidyOptSetValue( tdoc, TidyCharEncoding, "utf8" ) ? rc : -1 );
        }

        if ( rc >= 0 ) {
            HTMLTIDY_LOAD_CONFIG_HASH(tdoc,tidy_options);
        }

        if ( rc >= 0 ) {
            rc = tidySetErrorBuffer( tdoc, &errbuf );  // Capture diagnostics
        }

        if ( rc >= 0 ) {
            rc = tidyParseString( tdoc, input );   // Parse the input
        }

        if ( rc >= 0 ) {
            rc = tidyCleanAndRepair(tdoc);
        }

        if ( rc > 1 ) {
            rc = ( tidyOptSetBool( tdoc, TidyForceOutput, yes ) ? rc : -1 );
        }

        if ( rc >= 0) {
            rc = tidySaveBuffer( tdoc, &output );
        }

        if ( rc >= 0) {
            rc = tidyRunDiagnostics( tdoc );
        }

        if ( rc >= 0 && output.bp && errbuf.bp ) {
            XPUSHs( sv_2mortal(newSVpvn(output.bp, output.size)) );
            XPUSHs( sv_2mortal(newSVpvn(errbuf.bp, errbuf.size)) );

            /* TODO: Hoist this into a function */
            switch ( tidyOptGetInt(tdoc,TidyNewline) ) {
                case TidyLF:
                    newline = "\n";
                    break;
                case TidyCR:
                    newline = "\r";
                    break;
                default: 
                    newline = "\r\n";
                    break;
            }
            XPUSHs( sv_2mortal(newSVpv(newline, 0)) );
        }
        else {
            rc = -1;
        }

        tidyBufFree( &output );
        tidyBufFree( &errbuf );
        tidyRelease( tdoc );

        if ( rc < 0 ) {
            XSRETURN_UNDEF;
        }
#line 229 "Tidy.c"
	PUTBACK;
	return;
    }
}


XS(XS_HTML__Tidy__tidy_release_date); /* prototype to pass -Wmissing-prototypes */
XS(XS_HTML__Tidy__tidy_release_date)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: HTML::Tidy::_tidy_release_date()");
    {
#line 199 "Tidy.xs"
        const char* version;
#line 245 "Tidy.c"
	SV *	RETVAL;
#line 201 "Tidy.xs"
        version = tidyReleaseDate();
        RETVAL = newSVpv(version,0); /* will be automatically "mortalized" */
#line 250 "Tidy.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_HTML__Tidy); /* prototype to pass -Wmissing-prototypes */
XS(boot_HTML__Tidy)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXSproto("HTML::Tidy::_tidy_messages", XS_HTML__Tidy__tidy_messages, file, "$$$");
        newXSproto("HTML::Tidy::_tidy_clean", XS_HTML__Tidy__tidy_clean, file, "$$$");
        newXSproto("HTML::Tidy::_tidy_release_date", XS_HTML__Tidy__tidy_release_date, file, "");
    XSRETURN_YES;
}

